#include <bits/stdc++.h>

#define int int64_t

using namespace std;
int n, k, x;
int a[200010];
int pref[200010];

void podz2(){
    int sum = 0;
    for(int i = 1; i <= k; i++){
        sum+=min(i, x)*a[i];
    }
    cout << sum << " ";
    for(int i = 1; i <= n-k; i++){
        sum+=x*a[i+k];
        sum-=(pref[i+x-1]-pref[i-1]);
            cout << sum << " ";

    }

}

int32_t main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> k >> x;
    for(int i = 1; i <= n; i++) cin >> a[i];

    pref[0]=0;
    for(int i = 1; i <= n; i++){
        pref[i]=pref[i-1]+a[i];
    }

    bool l = true;
    for(int i = 1; i <= n; i++){
        if(a[i]<0) l = false;
    }
    if(l) podz2();

    return 0;
}